using System;
using System.Data;

namespace Demo_6_TypesService_Client
{
	class TypesServiceClient
	{
		static void Main(string[] args)
		{
			MyServices.TypesService service = 
				new MyServices.TypesService();

			// Invoke GetColors() web method
			MyServices.Color[] colors = service.GetColors();
			Console.WriteLine("Colors:");
			foreach (MyServices.Color color in colors)
			{
				Console.WriteLine(color);
			}

			// Invoke CalculateDistance() web method
			MyServices.Point p1 = new MyServices.Point();
			p1.x = 4;
			p1.y = 5;
			MyServices.Point p2 = new MyServices.Point();
			p2.x = 7;
			p2.y = -3;
			double distance = service.CalculateDistance(p1,p2);
			Console.WriteLine("\nDistance = {0}", distance);

			// Invoke ConvertDegreesToRadians(double angle)
			double angle = 90;
			service.ConvertDegreesToRadians(ref angle);
			Console.WriteLine("\nAngle in radians = {0}", angle);

			// Invoke GetStudents()
			MyServices.Student[] students = service.GetStudents();
			Console.WriteLine("\nStudents:");
			foreach (MyServices.Student student in students)
			{
				Console.WriteLine("{0} : {1}", student.Name, student.Age);
			}

			// Invoke GetDataSet()
			DataSet ds = service.GetDataSet();

			DataTable towns = ds.Tables["Towns"];
			Console.WriteLine("\nTowns:");
			foreach (DataRow town in towns.Rows)
			{
				Console.WriteLine("{0} : {1}", town["id"], town["name"]);
			}
			
			DataTable countries = ds.Tables["Countries"];
			Console.WriteLine("\nCountries:");
			foreach (DataRow country in countries.Rows)
			{
				Console.WriteLine("{0} : {1}", country["id"], country["name"]);
			}
		}
	}
}
